#!/usr/bin/env node


const http = require ("http");


var myArgs = process.argv.slice(2);

parser(myArgs);
    


//parser that will process individual commands
function parser (arguments) {
    // there are no commands that have more than 2 arguments
    if(arguments.length > 2){
        console.log("invalid arguments passed in "+ arguments);
        console.log("use -h for help");
        return -1;
    }

    else if(arguments.length ==1){
        // condition for printall
        if(arguments[0] === "printall"){
            //get /printall 
            httpGetCaller("printall");
            return;
        }
        // condition for help
        else if(arguments[0] === "-h"){
            printHelp();
            return;
        }
        else{
            // all other input of this length is invalid
            console.log("invalid arguments passed in "+ arguments);
            console.log("use -h for help");
            return -1;
        }
    }
    // parse the command and the word argument for 
    //  ADD, DELETE, CONTAINS, SUGGESTIONS
    var command = arguments[0];
    var word = arguments[1];

    var stringToBeSent = "";
    if(command === "add"){
        //get /add        
        httpGetCaller("add?word="+word);
        return;
    }
    else if(command === "delete"){
        //get /delete
        httpGetCaller("delete?word="+word);
        return;
    }
    else if(command === "contains"){
        //get /contains
        httpGetCaller("contains?word="+word);
        return;
    }
    else if(command === "suggestions"){
        //get suggestions
        httpGetCaller("suggestions?word="+word);
        return;
    }
    // not one of the specified functions
    // invalid command
    else{
        console.log("invalid arguments passed in "+ arguments);
        console.log("use -h for help");
        return -1;
    }
}

// make http request to server running on AWS instance
function httpGetCaller(str){
    var httpBeginning = "http://ec2-18-191-55-28.us-east-2.compute.amazonaws.com:8080/" // Public IPv4 DNS and Port number.
    http.get(httpBeginning+str, res => {
        let data = "";
        //collect response
        res.on("data", chunk => {
            data = data+= chunk;
        })
        res.on("end", ()=> {
            // parse response text and output it
            let op = JSON.parse(data).content;
            console.log(op);
        })
    });
    return;
}

// function that is triggered when command "skslingshotcli -h" is entered
function printHelp(){
    console.log("enter commands one at a time");
    console.log("possible commands to enter:");
    console.log("\tskslingshotcli add  <word>: Adds <word> to trie if trie does not contain <word>");
    console.log("\tskslingshotcli delete <word>: Deletes <word> from trie if trie contains <word>");
    console.log("\tskslingshotcli contains <word>: Indicates if <word> is present in the trie structure");
    console.log("\tskslingshotcli suggestions <word>: Gives a list of words that contain <word> as a prefix");
    console.log("\tskslingshotcli printall : Gives a list of all words stored in the trie structure");


}




